/*
 * Copyright (C) 2003 Bosselut Cyril <bosselut@b1project.com>
 */


#include <kapplication.h>
#include <kfiledialog.h>
#include <kaboutdata.h>
#include <kcmdlineargs.h>
#include <klocale.h>
#include <kconfig.h>
#include <ksimpleconfig.h>

#include <qurl.h>
#include <qfileinfo.h>
#include <qstringlist.h>

#include "theme_creator.h"
#include "kstartuplogo.h"


static const char *description = I18N_NOOP("A KDE Karamba theme creator");

static const char *version = "0.12";

static KCmdLineOptions options[] =
    {
        { "+file", I18N_NOOP("Theme to open."), 0 },
        { 0, 0, 0 }
    };

int main(int argc, char **argv)
{
    KAboutData about("KarthemeCreator", I18N_NOOP("KarthemeCreator"), version, description,
    KAboutData::License_GPL, "(C) 2003 Bosselut Cyril", 0, 0, "bosselut@b1project.com");
    about.addAuthor( "Bosselut Cyril",0 , "bosselut@b1project.com" );

    KCmdLineArgs::init(argc, argv, &about);
    KCmdLineArgs::addCmdLineOptions( options );

    KApplication app;
    Creator *mainWin = 0;

    KCmdLineArgs *args = KCmdLineArgs::parsedArgs();
    KStartupLogo* start_logo = 0L;
    start_logo = new KStartupLogo();
    start_logo -> setHideEnabled( true );
    start_logo->show();
    start_logo->raise();
    QApplication::flushX();
    sleep(2);
    delete start_logo;

    bool OK = false;
    if(args->count() > 0)
    {
        for (int i = 0; i < (args->count()); i++)
        {
            if( args->arg(i) != "" )
            {
                QFileInfo file( args->arg(i) );
                if( file.exists() && !file.isDir() )
                {
                    mainWin = new Creator( );
                    mainWin->fileOpen( args->arg(i) );
                    mainWin->show();
                    OK = true;
                }
            }
        }
        int ret = 0;
        if( OK )
            ret = app.exec();
        return ret;
    }
    else
    {
      mainWin = new Creator( );
      mainWin->show();
      int ret = 0;
      ret = app.exec();
      return ret;
    }

    args->clear();
    return 0;
}
